#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

char get_data()
{
	while (!(UCSR0A & (1<<RXC0)));
		return UDR0;
}

void vrum_vrum()
{

	PORTD &= ~(1 << PD7);
	PORTB &= ~(1 << PB1);
	PORTB &= ~(1 << PB2);
	PORTB &= ~(1 << PB4);
	PORTB &= ~(1 << PB5);

	while (1) {

		char move = get_data();

		switch (move)
		{
			case 'F':
				//Front
				PORTB |= (1 << PB1);
				PORTD |= (1 << PD7);

				//PORTB |= (1 << PB4);
				//PORTB |= (1 << PB2);
				break;

			case 'B':
				//Back
				PORTB |= (1 << PB5);
				PORTD &= ~(1 << PD7);
				
				//PORTB |= (1 << PB1);
				//PORTB |= (1 << PB5);
				break;

			case 'L':
				//Left
				PORTB |= (1 << PB4);
				break;

			case 'R':
				//Right
				PORTB |= (1 << PB2);
				break;

			case 'G':
				//Forward Left
				PORTD |= (1 << PD7);
				PORTB |= (1 << PB2);
				PORTB |= (1 << PB4);
				break;

			case 'I':
				//Forward right
				PORTD &= ~(1 << PD7);
				PORTB |= (1 << PB1);
				PORTB |= (1 << PB5);
				break;

			case 'H':
				//Back Left
				PORTB |= (1 << PB5);
				break;

			case 'J':
				//Back Right
				PORTB |= (1 << PB1);
				break;

			case 'S':
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB4);
				PORTB &= ~(1 << PB5);
				break;

			default :
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB4);
				PORTB &= ~(1 << PB5);
		}
	}
}

void init_usart()
{
	UCSR0A = 0;
	UCSR0B = _BV(RXEN0) | _BV(TXEN0); //enable RX and TX
	UCSR0C = _BV(UCSZ01) | _BV(UCSZ00); //1 byte of data
 
	int baud = 103;
	UBRR0= baud;

	DDRB |= (1 << PB1);
	DDRB |= (1 << PB2);
	DDRB |= (1 << PB4);
	DDRB |= (1 << PB5);

	DDRD |= (1 << PD7);

}

int main(void) {

	init_usart();
	vrum_vrum();
	
	return 0;
}